﻿/*
 *         Progetto: Accesso alle variabili condivise in mutua esclusione (costrutto lock)
 * 
 *           Autore: Roberto Fuligni
 *  Ultima modifica: 3/12/2018
 *  
 */

using System;
using System.Threading.Tasks;

namespace InterleavingLock
{
    class InterleavingLock
    {
        const int MAX_ITERAZIONI = 100000;
        static int N;
        // La variabile locker sarà utilizzata dal programma per controllare
        // l'accesso a una sezione critica in mutua esclusione
        static readonly object locker = new object();

        static void Main(string[] args)
        {
            Console.WriteLine("ACCESSO IN MUTUA ESCLUSIONE (LOCK)");
            N = 0;
            Parallel.Invoke(Incrementa, Decrementa);
            Console.WriteLine("N = {0}", N);
        }

        static void Incrementa()
        {
            int i, temp;

            i = 0;
            while (i < MAX_ITERAZIONI)
            {
                // Inizio della sezione critica (accesso alla variabile N regolato da lock)
                lock(locker)
                {
                    temp = N;
                    temp = temp + 1;
                    N = temp;
                }
                // Fine della sezione critica

                i++;
            }
        }

        static void Decrementa()
        {
            int i, temp;

            i = 0;
            while (i < MAX_ITERAZIONI)
            {
                // Inizio della sezione critica (accesso alla variabile N regolato da lock)
                lock (locker)
                {
                    temp = N;
                    temp = temp - 1;
                    N = temp;
                }
                // Fine della sezione critica

                i++;
            }
        }
    }
}
