﻿/*
 *         Progetto: Accesso alle variabili condivise in mutua esclusione (semaforo binario)
 * 
 *           Autore: Roberto Fuligni
 *  Ultima modifica: 3/12/2018
 *  
 */

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace InterleavingSemaforoBin
{
    class InterleavingSemaforoBin
    {
        const int MAX_ITERAZIONI = 100000;
        static int N;
        // Il semaforo binario (impostato inizialmente a 1) sarà utilizzato dal programma 
        // per controllare l'accesso a una sezione critica in mutua esclusione
        static SemaphoreSlim S = new SemaphoreSlim(1);

        static void Main(string[] args)
        {
            Console.WriteLine("ACCESSO IN MUTUA ESCLUSIONE (SEMAFORO BINARIO)");
            N = 0;
            Parallel.Invoke(Incrementa, Decrementa);
            Console.WriteLine("N = {0}", N);
        }

        static void Incrementa()
        {
            int i, temp;

            i = 0;
            while (i < MAX_ITERAZIONI)
            {
                // Attende che il semaforo sia pari a 1 (verde).
                // Quando il semaforo è verde, lo imposta a 0 (rosso) e prosegue
                S.Wait();

                // Inizio della sezione critica (accesso alla variabile N regolato da semaforo)
                temp = N;
                temp = temp + 1;
                N = temp;
                // Fine della sezione critica
                
                // Ripristina il semaforo a 1 (verde)
                S.Release();

                i++;
            }
        }

        static void Decrementa()
        {
            int i, temp;

            i = 0;
            while (i < MAX_ITERAZIONI)
            {
                // Attende che il semaforo sia pari a 1 (verde).
                // Quando il semaforo è verde, lo imposta a 0 (rosso) e prosegue
                S.Wait();

                // Inizio della sezione critica (accesso alla variabile N regolato da semaforo)
                temp = N;
                temp = temp - 1;
                N = temp;
                // Fine della sezione critica

                // Ripristina il semaforo a 1 (verde)
                S.Release();

                i++;
            }
        }
    }
}
